/* bwho.c - who.bz ported to Linux/C by Soda.
**
** 4/8:96 - imports class, nick, etc.. Seems stable - final?
**          version jumped to 2.5 to equal w/who.bz
** -todo- - 115k4 displaces rest of line. must fix.
**
**/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
// #include <time.h>

#include "../../bbbsdef.h"    /* bbbsdef.h from BBBS package */

/*struct noderec {          tempdir/bbbsnode 
  word            split;         (  0 ) unused 
  byte            bstatus;       (  2 ) Bit 0=MNP, 1=mailsession 
  byte            zstatus;       (  3 ) 0=off, 1=active, 2=not, 3=writing,
					4=grab, 5=down, 6=up, 7=chat, 8=door,
					9=groupchat, 10=telnet, 11=shelled.
  ulong           speed;         (  4 ) 0=local.
  word            time;          (  8 )
  word            endtime;       ( 10 ) when downloading.
  char            name[46];      ( 12 )
  char            realname[30];  ( 58 )
};                               ( 88 ) */

struct noderec      n;
FILE                *nodef, *classf;
char                nf[100], active[50], ircnick[50], class[50];
char                VERSION[30] = "v\e[1m2\e[0;32m.\e[1m9a";
int                 curnode;

void header()
{
  printf("\e[1;37m.\e[35m-\e[0;35m-------------------------------------------------------------------------\e[1;35m-\e[37m.\e[30m e\n");
//  printf("\e[1;35m|\e[0;32m# \e[1mS\e[0;32mpd  \e[1mS\e[0;32mtatus\e[10C\e[1mW\e[0;32mhen  \e[1mN\e[0;32mickname   \e[1mC\e[0;32mlass    \e[1mN\e[0;32mame\e[16Cv\e[1m1\e[0;32m.\e[1m9e \e[35m|\e[30m r\n");
  printf("\e[1;35m|\e[0;32m# \e[1mS\e[0;32mpd  \e[1mS\e[0;32mtatus\e[10C\e[1mW\e[0;32mhen  \e[1mN\e[0;32mickname   \e[1mC\e[0;32mlass    \e[1mN\e[0;32mame\e[16C%s \e[35m|\e[30m r\n", VERSION);
  printf("\e[1;37m`\e[35m-\e[0;35m-------------------------------------------------------------------------\e[1;35m-\e[37m'\e[30m s\n");
  printf("\e[0m");
}


void getstatus()
{
  char temp[100];

  if ( (strchr(n.realname, ':')) && (strchr(n.realname, '/')) && (strchr(n.realname, '.')) )
  { 
    strcpy(ircnick, "Mail-poll");
    strcpy(class, "Fido");
  } else if (n.realname[0] == '\0')
  {
    strcpy(ircnick, "-");
    strcpy(class,"-");
    strcpy(n.realname, "-");
  } else
  {

    sprintf(temp, "/home/bbs/temp/class.%u", curnode);

    if ( (classf=fopen(temp, "rt")) == NULL)
    {
      // Log this, ok?
      strcpy(ircnick, "No file");
      strcpy(class, "No file");
      strcpy(active, "Active");
    }
    else
    {
      fgets(ircnick, 40, classf);
      fgets(class, 40, classf);
      fgets(active, 40, classf);
      fclose(classf);
      
      ircnick[strlen(ircnick)-1] = '\0';
      
//      if((n.nick[0]=='\0') && (ircnick[0]!='\0'))
//        strcpy(n.nick, ircnick);
      
      class[strlen(class)-1] = '\0';

      if (active[0] != '\n')
        active[strlen(active)-1] = '\0';
      else
        strcpy(active, "Active");

    }
  }
}

void dspeed()
{
  if (n.speed > 100000)
    printf("\e[0m%3luk ", n.speed/1000);
  else if (n.speed > 1)
    printf("\e[0m%2luk%lu ", n.speed/1000, (n.speed-(n.speed/1000*1000))/100);
  else if (n.speed==1)
    printf(" \e[0mnet ");
  else /* n.speed == 0 */
    printf(" \e[0mloc ");
}

void dstatus()
{
//  char *active;

  if (n.zstatus==0)
    printf("\e[36m");
  else
    printf("\e[1m");
  
  if      (n.zstatus==0) strcpy(active,"Logged off");
  else if (n.zstatus==2) strcpy(active,"Not avail.");
  else if (n.zstatus==3) strcpy(active,"Writing");
  else if (n.zstatus==4) strcpy(active,"Grabbing");
  else if (n.zstatus==5) strcpy(active,"Downloading");
  else if (n.zstatus==6) strcpy(active,"Uploading");
  else if (n.zstatus==7) strcpy(active,"Chat");
  else if (n.zstatus==8) strcpy(active,"Using a door");
  else if (n.zstatus==9) strcpy(active,"Groupchat");
  else if (n.zstatus==10) strcpy(active,"Telnet");
  else if (n.zstatus==11) strcpy(active,"Shelling");

  printf("%-16s", active);
}

void dtime()
{
  if (n.zstatus!=0)
    printf("\e[0m");
  printf("%02u:%02u ", (n.time/256), (n.time%256));
}

void dnick()
{
  if (n.zstatus!=0)
    printf("\e[1;33m");

  printf("%-11s", n.nick);
}

void dclass()
{
  if (n.zstatus!=0)
    printf("\e[0;1m");

  printf("%-9s", class);
}

void footer()
{
  printf("\e[0m\n");
}

void main (int argc, char **argv)
{

/*  if (argc!=3 && argc!=2) {
    fprintf(stderr,"Usage: %s [nodefile]\n",argv[0]);
    return 1;
  }*/

  if (argc<2)
    strcpy(nf, "/home/bbs/temp/bbbsnode");
  else
    strcpy(nf,argv[1]);

  if ( (nodef=fopen(nf,"rb")) == NULL )
  {
    fprintf(stderr,"Couldn't open file %s for binary read!\n", nf);
    return;
  }

  header();

  curnode=1;
  while (fread(&n, sizeof(n), 1, nodef))
  {
    printf("\e[0;32m%2u ", curnode);
    dspeed();
    getstatus();
    dstatus();
    dtime();
    dnick();
    dclass();
    printf("%s\n", n.realname);
    curnode++;
  }
  fclose(nodef);
  footer();
}
